﻿using System.Reflection.Emit;

namespace Fipscode.CodeGenerator
{
    class Module
    {
        public ModuleBuilder Builder { get; set; }
        public Assembly Assembly { get; set; }

        public Module(Assembly assembly, string moduleName = null, string dllName = null)
        {
            Builder = Generator.NewModule(assembly.Builder, moduleName, dllName);
            Assembly = assembly;
        }

        public Type AddType(string className = null)
        {
            return new Type(this, className);
        }

        public Type AddType(string className = null, params string[] genericParameters)
        {
            return new Type(this, className, genericParameters);
        }
    }
}
