﻿using System.Reflection.Emit;
using s = System;

namespace Fipscode.CodeGenerator
{
    class Type
    {
        public TypeBuilder Builder { get; set; }
        public Module Module { get; set; }

        public Type(Module module, string className = null)
        {
            Builder = Generator.NewType(module.Builder, className);
            Module = module;
        }

        public Type(Module module, string className = null, params string[] genericParameters)
        {
            Builder = Generator.NewType(module.Builder, className, genericParameters);
            Module = module;
        }

        public Method AddMethod(string methodName)
        {
            return new Method(this, methodName);
        }

        public Method AddMethod(string methodName, s.Type returnType, params s.Type[] parameterTypes)
        {
            return new Method(this, methodName, returnType, parameterTypes);
        }

        public Method AddMethod(string methodName, s.Type returnType, string[] genericParameters, params s.Type[] parameterTypes)
        {
            return new Method(this, methodName, returnType, genericParameters, parameterTypes);
        }
    }
}
