﻿using System.Linq;

namespace Fipscode.Conventions
{
    public class CamelCaseToDashConvention : IConvention
    {
        private string CamelCaseToDash(string value)
        {
            return string.Concat(value.Select((c, i) => i > 0 && char.IsUpper(c) ? "-" + char.ToLower(c) : c.ToString()));
        }

        public string PropertyToField(string propertyName)
        {
            return CamelCaseToDash(propertyName);
        }

        public string TypeToEntity(string typeName)
        {
            return CamelCaseToDash(typeName);
        }

        public string NamespaceToEntity(string namespaceName)
        {
            return CamelCaseToDash(namespaceName.Replace(".", ""));
        }
    }
}
