﻿using System.Linq;

namespace Fipscode.Conventions
{
    public class CamelCaseToUnderscoreConvention : IConvention
    {
        private string CamelCaseToUnderscore(string value)
        {
            return string.Concat(value.Select((c, i) => i > 0 && char.IsUpper(c) ? "_" + char.ToLower(c) : c.ToString()));
        }

        public string PropertyToField(string propertyName)
        {
            return CamelCaseToUnderscore(propertyName);
        }

        public string TypeToEntity(string typeName)
        {
            return CamelCaseToUnderscore(typeName);
        }

        public string NamespaceToEntity(string namespaceName)
        {
            return CamelCaseToUnderscore(namespaceName.Replace(".", ""));
        }
    }
}
