﻿using System.Collections.Generic;
using System.Reflection;
using System.Runtime.Loader;

namespace Fipscode.Loader
{
    public abstract class AssemblyLoaderBase : IAssemblyLoader
    {
        public virtual ICollection<Assembly> Assemblies { get; } = new List<Assembly>();

        public abstract void LoadAssemblies();

        protected Assembly Load(string path)
        {
            var ret = AssemblyLoadContext.Default.LoadFromAssemblyPath(path);
            Assemblies.Add(ret);
            return ret;
        }
    }
}
