﻿using System;

namespace Fipscode.Loader.Filters
{
    public class And : IFilter
    {
        public IFilter[] Filters { get; }

        public And(params IFilter[] filters) => Filters = filters;

        public bool Filter(Type type)
        {
            foreach (var filter in Filters) {
                if (!filter.Filter(type)) {
                    return false;
                }
            }
            return true;
        }
    }
}
