﻿using System;

namespace Fipscode.Loader.Filters
{
    public class Or : IFilter
    {
        public IFilter[] Filters { get; }

        public Or(params IFilter[] filters) => Filters = filters;

        public bool Filter(Type type)
        {
            foreach (var filter in Filters) {
                if (filter.Filter(type)) {
                    return true;
                }
            }
            return false;
        }
    }
}
