﻿using System;
using System.Collections.Generic;
using Fipscode.Loader.Filters;

namespace Fipscode.Loader
{
    public class Loader
    {
        public ICollection<IAssemblyLoader> AssemblyLoaders { get; }

        public Loader(params IAssemblyLoader[] assemblyLoaders)
        {
            foreach (var loader in assemblyLoaders) {
                AssemblyLoaders.Add(loader);
            }
        }

        public void Load()
        {
            foreach (var loader in AssemblyLoaders) {
                loader.LoadAssemblies();
            }
        }

        public Type[] GetTypes(IFilter filter)
        {
            var ret = new List<Type>();
            foreach (var loader in AssemblyLoaders) {
                foreach (var assembly in loader.Assemblies) {
                    foreach (var type in assembly.GetTypes()) {
                        if (filter.Filter(type)) {
                            ret.Add(type);
                        }
                    }
                }
            }
            return ret.ToArray();
        }
    }
}
